/*** Generated by streamline 0.3.6 (callbacks) - DO NOT EDIT ***/
var __rt=require('streamline/lib/callbacks/runtime').runtime(__filename),__func=__rt.__func,__cb=__rt.__cb,__tryCatch=__rt.__tryCatch,__propagate=__rt.__propagate,__trap=__rt.__trap,__future=__rt.__future,__setEF=__rt.__setEF,__g=__rt.__g;
/*     1 */ var common = require("../common");
/*    20 */ var fs = require("fs");
/*    21 */ var path = require("path");
/*    22 */ var url = require("url");
/*    23 */ var crypto = require("crypto");
/*    24 */ var pfx2pem = require("../../util/certificates/pkcs").pfx2pem;
/*    25 */ var Channel = require("../channel");
/*    26 */ var async = require("async");
/*    27 */ var child_process = require("child_process");
/*    28 */ var utils = require("../utils");
/*    29 */ var constants = require("../constants");
/*    30 */ var cacheUtils = require("../cacheUtils");
/*    32 */ exports.init = function(cli) {
/*    34 */   var log = cli.output;
/*    35 */   var site = cli.category("site");
/*    36 */   var scm = site.category("deployment").description("Commands to manage your git deployments");
/*    39 */   function getScmChannel(context) {
/*    40 */     var parts = url.parse(context.repositoryUri);
/*    41 */     var channel = new Channel({
/*    42 */       host: parts.hostname,
/*    43 */       port: (((parts.port && parseInt(parts.port, 10))) || ((/https/i.test(parts.protocol) ? 443 : 80))),
/*    44 */       auth: context.repositoryAuth
                });
/*    47 */     var proxyString = (((process.env.HTTPS_PROXY || process.env.https_proxy) || process.env.ALL_PROXY) || process.env.all_proxy);
/*    53 */     if ((proxyString !== undefined)) {
/*    54 */       var proxyUrl = url.parse(proxyString);
/*    55 */       if (((proxyUrl.protocol !== "http:") && (proxyUrl.protocol !== "https:"))) {
/*    58 */         proxyUrl = url.parse(("http://" + proxyString));
                  }
                ;
/*    61 */       channel = channel.add({
/*    61 */         proxy: proxyUrl
                  });
                }
              ;
/*    64 */     return channel;
              };
/*    66 */   scm.getScmChannel = getScmChannel;
/*    68 */   scm.command("list [name]").whiteListPowershell().usage("[options] [name]").description("List your git deployments").option("-s, --subscription <id>", "use the subscription id").option("-m, --max <count>", "limit the maximum number of results").execute(function __1(name, options, _) {
                var context, repositoryUri;
                var __frame = {
                  name: "__1",
                  line: 74
                };
                return __func(_, this, arguments, __1, 2, __frame, function __$__1() {
/*    75 */       context = {
/*    76 */         subscription: cli.category("account").lookupSubscriptionId(options.subscription),
/*    77 */         maxItems: options.max,
/*    78 */         site: {
/*    79 */           name: name
                    }
                  };
/*    83 */       return ensureRepositoryUri(context, __cb(_, __frame, 9, 26, function ___(__0, __1) {
                    repositoryUri = __1;
                    return (function __$__1(__then) {
/*    84 */           if (repositoryUri) {
/*    85 */             return listDeployments(context, __cb(_, __frame, 11, 8, __then, true));
                      }
                       else {
/*    87 */             log.error("Repository is not setup");
                        __then();
                      }
                    ;
                    })(_);
                  }, true));
                });
              });
/*    91 */   scm.command("show <commitId> [name]").whiteListPowershell().usage("[options] <commitId> [name]").description("Show your git deployment").option("-s, --subscription <id>", "use the subscription id").option("-d, --details", "display log details").execute(function __2(commitId, name, options, _) {
                var context, repositoryUri, deployment, data, logs, i, details, j;
                var __frame = {
                  name: "__2",
                  line: 97
                };
                return __func(_, this, arguments, __2, 3, __frame, function __$__2() {
/*    98 */       context = {
/*    99 */         subscription: cli.category("account").lookupSubscriptionId(options.subscription),
/*   100 */         shortId: commitId,
/*   101 */         site: {
/*   102 */           name: name
                    }
                  };
/*   106 */       return cacheUtils.readCommitId(context, __cb(_, __frame, 9, 25, function ___(__0, __2) {
/*   106 */         var __1 = !(context.id = __2);
                    return (function __$__2(__then) {
                      if (__1) {
/*   107 */             return _(null, log.error((("deployment with " + commitId) + " does not exist")));
                      }
                       else {
                        __then();
                      }
                    ;
                    })(function __$__2() {
/*   110 */           return ensureRepositoryUri(context, __cb(_, __frame, 13, 26, function ___(__0, __3) {
                        repositoryUri = __3;
                        return (function __$__2(__then) {
/*   111 */               if (repositoryUri) {
/*   112 */                 return scm.doDeploymentGet(context, __cb(_, __frame, 15, 25, function ___(__0, __4) {
                              deployment = __4;
                              return (function __$__2(__then) {
/*   114 */                     if (log.format().json) {
/*   115 */                       data = deployment;
                                  return (function __$__2(__then) {
/*   116 */                         if (options.details) {
/*   117 */                           return getLogDetails(context, __cb(_, __frame, 20, 24, function ___(__0, __5) {
/*   117 */                             data.logs = __5;
                                        __then();
                                      }, true));
                                    }
                                     else {
                                      __then();
                                    }
                                  ;
                                  })(function __$__2() {
/*   120 */                         log.json(data);
                                    __then();
                                  });
                                }
                                 else {
/*   122 */                       site.logEachData("info", deployment);
                                  return (function __$__2(__then) {
/*   123 */                         if (options.details) {
/*   124 */                           return getLogDetails(context, __cb(_, __frame, 27, 23, function ___(__0, __6) {
                                        logs = __6;
/*   125 */                             for (i = 0; (i < logs.length); ++i) {
/*   126 */                               displayLog(logs[i]);
/*   127 */                               if (logs[i].details) {
/*   128 */                                 details = logs[i].details;
/*   129 */                                 for (j = 0; (j < details.length); ++j) {
/*   130 */                                   displayLog(details[j]);
                                            };
                                          }
                                        ;
                                        };
                                        __then();
                                      }, true));
                                    }
                                     else {
/*   135 */                           log.help("To see more details, specify -d or --details option");
                                      __then();
                                    }
                                  ;
                                  })(__then);
                                }
                              ;
                              })(__then);
                            }, true));
                          }
                           else {
/*   139 */                 log.error("Repository is not setup");
                            __then();
                          }
                        ;
                        })(_);
                      }, true));
                    });
                  }, true));
                });
              });
/*   143 */   scm.command("redeploy <commitId> [name]").whiteListPowershell().usage("[options] <commitId> [name]").description("Redeploy your git deployment").option("-s, --subscription <id>", "use the subscription id").option("-q, --quiet", "quiet mode, do not ask for redeploy confirmation").execute(function __3(commitId, name, options, _) {
                var context, repositoryUri;
                var __frame = {
                  name: "__3",
                  line: 149
                };
                return __func(_, this, arguments, __3, 3, __frame, function __$__3() {
/*   150 */       context = {
/*   151 */         subscription: cli.category("account").lookupSubscriptionId(options.subscription),
/*   152 */         shortId: commitId,
/*   153 */         site: {
/*   154 */           name: name
                    }
                  };
/*   158 */       return cacheUtils.readCommitId(context, __cb(_, __frame, 9, 25, function ___(__0, __3) {
/*   158 */         var __2 = !(context.id = __3);
                    return (function __$__3(__then) {
                      if (__2) {
/*   159 */             return _(null, log.error((("deployment with " + commitId) + " does not exist")));
                      }
                       else {
                        __then();
                      }
                    ;
                    })(function __$__3() {
/*   162 */           return ensureRepositoryUri(context, __cb(_, __frame, 13, 26, function ___(__0, __4) {
                        repositoryUri = __4;
                        return (function __$__3(__then) {
/*   163 */               if (repositoryUri) {
                            return (function __$__3(_) {
/*   164 */                   var __1 = !options.quiet;
                              if (!__1) {
                                return _(null, __1);
                              }
                            ;
/*   164 */                   return site.confirm((("Reploy deployment with " + context.shortId) + " id?  (y/n) "), __cb(_, __frame, 15, 31, function ___(__0, __3) {
/*   164 */                     var __2 = !__3;
                                return _(null, __2);
                              }, true));
                            })(__cb(_, __frame, -148, 17, function ___(__0, __5) {
                              return (function __$__3(__then) {
                                if (__5) {
                                  return _(null);
                                }
                                 else {
                                  __then();
                                }
                              ;
                              })(function __$__3() {
/*   167 */                     return scm.doDeploymentPut(context, __cb(_, __frame, 18, 8, function __$__3() {
/*   168 */                       return listDeployments(context, __cb(_, __frame, 19, 8, __then, true));
                                }, true));
                              });
                            }, true));
                          }
                           else {
/*   170 */                 log.error("Repository is not setup");
                            __then();
                          }
                        ;
                        })(_);
                      }, true));
                    });
                  }, true));
                });
              });
/*   174 */   scm.doDeploymentsGet = function scm_doDeploymentsGet__4(context, _) {
                var maxItems, channel, progress, deployments;
                var __frame = {
                  name: "scm_doDeploymentsGet__4",
                  line: 174
                };
                return __func(_, this, arguments, scm_doDeploymentsGet__4, 1, __frame, function __$scm_doDeploymentsGet__4() {
/*   175 */       maxItems = parseInt(context.maxItems, 10);
/*   176 */       if ((!maxItems || (maxItems <= 0))) {
/*   177 */         maxItems = 20;
                  }
                ;
/*   183 */       channel = getScmChannel(context).path("deployments").query("$orderby", "ReceivedTime desc").query("$top", maxItems);
/*   185 */       progress = cli.progress("Enumerating deployments");
                  return (function ___(__then) {
                    (function ___(_) {
                      __tryCatch(_, function __$scm_doDeploymentsGet__4() {
/*   187 */             return channel.GET(__cb(_, __frame, 13, 44, function ___(__0, __1) {
/*   187 */               deployments = ensureShortCommitId(__1);
/*   188 */               return cacheUtils.saveCommitIds(context, deployments, __cb(_, __frame, 14, 6, function __$scm_doDeploymentsGet__4() {
/*   189 */                 return _(null, deployments.map(formatDeployment));
                          }, true));
                        }, true));
                      });
                    })(function ___(__e, __r, __cont) {
                      (function ___(__then) {
                        __tryCatch(_, function __$scm_doDeploymentsGet__4() {
/*   191 */               progress.end();
                          __then();
                        });
                      })(function ___() {
                        __tryCatch(_, function ___() {
                          if (__cont) {
                            __then();
                          } else {
                            _(__e, __r);
                          };
                        });
                      });
                    });
                  })(function ___() {
                    __tryCatch(_, _);
                  });
                });
              };
/*   195 */   scm.doDeploymentGet = function scm_doDeploymentGet__5(context, _) {
                var channel, progress;
                var __frame = {
                  name: "scm_doDeploymentGet__5",
                  line: 195
                };
                return __func(_, this, arguments, scm_doDeploymentGet__5, 1, __frame, function __$scm_doDeploymentGet__5() {
/*   198 */       channel = getScmChannel(context).path("deployments").path(context.id);
/*   199 */       progress = cli.progress("Retrieving deployment info");
                  return (function ___(__then) {
                    (function ___(_) {
                      __tryCatch(_, function __$scm_doDeploymentGet__5() {
/*   201 */             return channel.GET(__cb(_, __frame, 6, 30, function ___(__0, __2) {
/*   201 */               var __1 = formatDeployment(__2);
                          return _(null, __1);
                        }, true));
                      });
                    })(function ___(__e, __r, __cont) {
                      (function ___(__then) {
                        __tryCatch(_, function __$scm_doDeploymentGet__5() {
/*   203 */               progress.end();
                          __then();
                        });
                      })(function ___() {
                        __tryCatch(_, function ___() {
                          if (__cont) {
                            __then();
                          } else {
                            _(__e, __r);
                          };
                        });
                      });
                    });
                  })(function ___() {
                    __tryCatch(_, _);
                  });
                });
              };
/*   207 */   scm.doDeploymentPut = function scm_doDeploymentPut__6(context, _) {
                var channel, progress;
                var __frame = {
                  name: "scm_doDeploymentPut__6",
                  line: 207
                };
                return __func(_, this, arguments, scm_doDeploymentPut__6, 1, __frame, function __$scm_doDeploymentPut__6() {
/*   210 */       channel = getScmChannel(context).path("deployments").path(context.id);
/*   211 */       progress = cli.progress("Redeploying deployment");
                  return (function ___(__then) {
                    (function ___(_) {
                      __tryCatch(_, function __$scm_doDeploymentPut__6() {
/*   213 */             return channel.PUT(null, __cb(_, __frame, 6, 13, _, true));
                      });
                    })(function ___(__e, __r, __cont) {
                      (function ___(__then) {
                        __tryCatch(_, function __$scm_doDeploymentPut__6() {
/*   215 */               progress.end();
                          __then();
                        });
                      })(function ___() {
                        __tryCatch(_, function ___() {
                          if (__cont) {
                            __then();
                          } else {
                            _(__e, __r);
                          };
                        });
                      });
                    });
                  })(function ___() {
                    __tryCatch(_, _);
                  });
                });
              };
/*   219 */   scm.doLogGet = function scm_doLogGet__7(context, _) {
                var channel, progress, logs;
                var __frame = {
                  name: "scm_doLogGet__7",
                  line: 219
                };
                return __func(_, this, arguments, scm_doLogGet__7, 1, __frame, function __$scm_doLogGet__7() {
/*   223 */       channel = getScmChannel(context).path("deployments").path(context.id).path("log");
/*   224 */       progress = cli.progress("Retrieving deployment log info");
                  return (function ___(__then) {
                    (function ___(_) {
                      __tryCatch(_, function __$scm_doLogGet__7() {
/*   226 */             return channel.GET(__cb(_, __frame, 7, 17, function ___(__0, __1) {
                          logs = __1;
/*   227 */               return _(null, logs.map(formatLog));
                        }, true));
                      });
                    })(function ___(__e, __r, __cont) {
                      (function ___(__then) {
                        __tryCatch(_, function __$scm_doLogGet__7() {
/*   229 */               progress.end();
                          __then();
                        });
                      })(function ___() {
                        __tryCatch(_, function ___() {
                          if (__cont) {
                            __then();
                          } else {
                            _(__e, __r);
                          };
                        });
                      });
                    });
                  })(function ___() {
                    __tryCatch(_, _);
                  });
                });
              };
/*   233 */   function listDeployments(context, _) {
                var deployments, authorLength, messageLength;
                var __frame = {
                  name: "listDeployments",
                  line: 233
                };
                return __func(_, this, arguments, listDeployments, 1, __frame, function __$listDeployments() {
/*   234 */       return scm.doDeploymentsGet(context, __cb(_, __frame, 1, 22, function ___(__0, __1) {
                    deployments = __1;
/*   235 */         authorLength = 0;
/*   235 */         messageLength = 0;
/*   236 */         if ((deployments && deployments.length)) {
/*   237 */           log.table(deployments, function(row, deployment) {
/*   238 */             row.cell("Time", deployment.start_time);
/*   239 */             row.cell("Commit id", deployment.shortId);
/*   240 */             row.cell("Status", deployment.status);
/*   241 */             authorLength = Math.max(deployment.author.length, authorLength);
/*   242 */             row.cell("Author", deployment.author, null, Math.min(authorLength, 15));
/*   243 */             messageLength = Math.max(deployment.message.length, messageLength);
/*   244 */             row.cell("Message", deployment.message, null, Math.min(messageLength, 40));
                      });
                    }
/*   246 */          else {
/*   247 */           log.info("No git deployment found");
                    }
                  ;
                    _();
                  }, true));
                });
              };
/*   251 */   function getLogDetails(context, _) {
                var results, logs, progress, i;
                var __frame = {
                  name: "getLogDetails",
                  line: 251
                };
                return __func(_, this, arguments, getLogDetails, 1, __frame, function __$getLogDetails() {
/*   253 */       return scm.doLogGet(context, __cb(_, __frame, 2, 15, function ___(__0, __2) {
                    logs = __2;
                    return (function __$getLogDetails(__then) {
/*   254 */           if ((logs && logs.length)) {
/*   255 */             progress = cli.progress("Retrieving log details");
                        return (function ___(__then) {
                          (function ___(_) {
                            __tryCatch(_, function __$getLogDetails() {
/*   257 */                   return async.map(logs, function __1(log, _) {
                                var details;
                                var __frame = {
                                  name: "__1",
                                  line: 257
                                };
                                return __func(_, this, arguments, __1, 1, __frame, function __$__1() {
                                  return (function __$__1(__then) {
/*   258 */                         if (log.hasDetails) {
/*   264 */                           return getScmChannel(context).path("deployments").path(context.id).path("log").path(log.id).GET(__cb(_, __frame, 7, 26, function ___(__0, __1) {
                                        details = __1;
/*   265 */                             return _(null, details.map(formatLog));
                                      }, true));
                                    }
                                     else {
                                      __then();
                                    }
                                  ;
                                  })(_);
                                });
                              }, __cb(_, __frame, 6, 18, function ___(__0, __3) {
/*   257 */                     results = __3;
                                _(null, null, true);
                              }, true));
                            });
                          })(function ___(__e, __r, __cont) {
                            (function ___(__then) {
                              __tryCatch(_, function __$getLogDetails() {
/*   269 */                     progress.end();
                                __then();
                              });
                            })(function ___() {
                              __tryCatch(_, function ___() {
                                if (__cont) {
                                  __then();
                                } else {
                                  _(__e, __r);
                                };
                              });
                            });
                          });
                        })(function ___() {
                          __tryCatch(_, function __$getLogDetails() {
/*   272 */                 for (i = 0; (i < logs.length); ++i) {
/*   273 */                   if (results[i]) {
/*   274 */                     logs[i].details = results[i];
                              }
                            ;
                            };
/*   278 */                 return _(null, logs);
                          });
                        });
                      }
                       else {
/*   280 */             log.info("deployment has no detail");
/*   281 */             return _(null, []);
                      }
                    ;
                    })(_);
                  }, true));
                });
              };
/*   285 */   function displayLog(item) {
/*   286 */     if ((item.type === "Warning")) {
/*   287 */       log.warn(((item.short_time + " ") + item.message));
                }
/*   288 */      else if ((item.type === "Error")) {
/*   289 */       log.error(((item.short_time + " ") + item.message));
                }
/*   290 */      else {
/*   291 */       log.data(((item.short_time + " ") + item.message));
                }
                
              ;
              };
/*   295 */   function fromJsonDate(str) {
/*   296 */     return eval(str.replace(/\/Date\((.*)[+].*\)\//gi, "new Date($1)"));
              };
/*   299 */   function formatDate(dt) {
/*   300 */     var date = dt.getDate(), month = (dt.getMonth() + 1);
/*   302 */     date = ((((date < 10) ? "0" : "")) + date);
/*   303 */     month = ((((month < 10) ? "0" : "")) + month);
/*   304 */     return ((((((dt.getFullYear() + "-") + month) + "-") + date) + " ") + dt.toLocaleTimeString());
              };
/*   307 */   function dateTimeText(str) {
/*   308 */     return formatDate(fromJsonDate(str));
              };
/*   311 */   function deploymentStatusText(status) {
/*   312 */     switch (status) {
/*   313 */     case 0:
/*   313 */       return "Pending";
/*   313 */     case 1:
/*   314 */       return "Building";
/*   314 */     case 2:
/*   315 */       return "Deploying";
/*   315 */     case 3:
/*   316 */       return "Failed";
/*   316 */     case 4:
/*   317 */       return "Success";
/*   317 */       default:
/*   318 */       return "Unknown";
/*   318 */     };
              };
/*   322 */   function logTypeText(type) {
/*   323 */     switch (type) {
/*   324 */     case 0:
/*   324 */       return "Message";
/*   324 */     case 1:
/*   325 */       return "Warning";
/*   325 */     case 2:
/*   326 */       return "Error";
/*   326 */       default:
/*   327 */       return "Unknown";
/*   327 */     };
              };
/*   331 */   function ensureShortCommitId(deployments) {
/*   332 */     return deployments.map(function(deployment) {
/*   333 */       deployment.shortId = deployment.id.substr(0, 10);
/*   334 */       return deployment;
                });
              };
/*   338 */   function ensureRepositoryUri(context, _) {
                var siteData, repositoryUri;
                var __frame = {
                  name: "ensureRepositoryUri",
                  line: 338
                };
                return __func(_, this, arguments, ensureRepositoryUri, 1, __frame, function __$ensureRepositoryUri() {
/*   339 */       return site.lookupSiteNameAndWebSpace(context, __cb(_, __frame, 1, 19, function ___(__0, __1) {
                    siteData = __1;
/*   340 */         repositoryUri = (siteData && site.getRepositoryUri(siteData));
                    return (function __$ensureRepositoryUri(__then) {
/*   341 */           if (!repositoryUri) {
/*   342 */             return site.doSiteGet(context, __cb(_, __frame, 4, 17, function ___(__0, __2) {
/*   342 */               siteData = __2;
/*   343 */               repositoryUri = site.getRepositoryUri(siteData);
                          __then();
                        }, true));
                      }
                       else {
                        __then();
                      }
                    ;
                    })(function __$ensureRepositoryUri() {
/*   345 */           if (repositoryUri) {
/*   346 */             context.repositoryAuth = site.getRepositoryAuth(siteData);
/*   347 */             return _(null, context.repositoryUri = repositoryUri);
                      }
                    ;
                      _();
                    });
                  }, true));
                });
              };
/*   350 */   scm.ensureRepositoryUri = ensureRepositoryUri;
/*   352 */   function formatDeployment(deployment) {
/*   353 */     var timeProperties = ["end_time","last_success_end_time","received_time","start_time",];
/*   354 */     for (var i = 0; (i < timeProperties.length); ++i) {
/*   355 */       if (deployment[timeProperties[i]]) {
/*   356 */         deployment[timeProperties[i]] = dateTimeText(deployment[timeProperties[i]]);
                  }
                ;
                };
/*   359 */     deployment.complete = (!!deployment.complete).toString();
/*   360 */     deployment.status = (deployment.active ? "Active" : deploymentStatusText(deployment.status));
/*   361 */     deployment.message = deployment.message.replace(/\s*(.*)\s*?/g, "$1");
/*   362 */     delete deployment.active;
/*   363 */     delete deployment.status_text;
/*   364 */     delete deployment.url;
/*   365 */     delete deployment.log_url;
/*   366 */     return deployment;
              };
/*   369 */   function formatLog(log) {
/*   370 */     log.hasDetails = !!log.details_url;
/*   371 */     log.log_time = (log.log_time && dateTimeText(log.log_time));
/*   372 */     log.short_time = (log.log_time && log.log_time.replace(/.* +(.*)/g, "$1"));
/*   373 */     log.type = logTypeText(log.type);
/*   374 */     log.shortId = log.id.substr(0, 10);
/*   375 */     delete log.details_url;
/*   376 */     return log;
              };
            };
