/*** Generated by streamline 0.3.6 (callbacks) - DO NOT EDIT ***/
var __rt=require('streamline/lib/callbacks/runtime').runtime(__filename),__func=__rt.__func,__cb=__rt.__cb,__tryCatch=__rt.__tryCatch,__propagate=__rt.__propagate,__trap=__rt.__trap,__future=__rt.__future,__setEF=__rt.__setEF,__g=__rt.__g;
/*     1 */ var common = require("../common");
/*    17 */ var fs = require("fs");
/*    18 */ var path = require("path");
/*    19 */ var url = require("url");
/*    20 */ var crypto = require("crypto");
/*    21 */ var pfx2pem = require("../../util/certificates/pkcs").pfx2pem;
/*    22 */ var Channel = require("../channel");
/*    23 */ var async = require("async");
/*    24 */ var child_process = require("child_process");
/*    25 */ var utils = require("../utils");
/*    26 */ var constants = require("../constants");
/*    27 */ var cacheUtils = require("../cacheUtils");
/*    29 */ exports.init = function(cli) {
/*    31 */   var log = cli.output;
/*    33 */   function getChannel() {
/*    34 */     var account = cli.category("account");
/*    35 */     var managementEndpoint = url.parse(utils.getManagementEndpointUrl(account.managementEndpointUrl()));
/*    36 */     var pem = account.managementCertificate();
/*    37 */     var host = managementEndpoint.hostname;
/*    38 */     var port = managementEndpoint.port;
/*    40 */     var channel = new Channel({
/*    41 */       host: host,
/*    42 */       port: port,
/*    43 */       key: pem.key,
/*    44 */       cert: pem.cert
/*    45 */     }).header("x-ms-version", "2011-02-25");
/*    47 */     var proxyString = (((process.env.HTTPS_PROXY || process.env.https_proxy) || process.env.ALL_PROXY) || process.env.all_proxy);
/*    53 */     if ((proxyString !== undefined)) {
/*    54 */       var proxyUrl = url.parse(proxyString);
/*    55 */       if (((proxyUrl.protocol !== "http:") && (proxyUrl.protocol !== "https:"))) {
/*    58 */         proxyUrl = url.parse(("http://" + proxyString));
                  }
                ;
/*    61 */       channel = channel.add({
/*    61 */         proxy: proxyUrl
                  });
                }
              ;
/*    64 */     return channel;
              };
/*    67 */   var site = cli.category("site").description("Commands to manage your web sites");
/*    70 */   site.command("list").whiteListPowershell().description("List your web sites").option("-s, --subscription <id>", "use the subscription id").execute(function __1(options, _) {
                var parameters, sites, s;
                var __frame = {
                  name: "__1",
                  line: 74
                };
                return __func(_, this, arguments, __1, 1, __frame, function __$__1() {
/*    75 */       parameters = {
/*    76 */         subscription: cli.category("account").lookupSubscriptionId(options.subscription)
                  };
/*    79 */       return site.doSitesGet(parameters, __cb(_, __frame, 5, 22, function ___(__0, __1) {
                    sites = __1;
/*    81 */         if ((sites && (sites.length > 0))) {
/*    82 */           for (s in sites) {
/*    83 */             sites[s] = clean(sites[s]);
                      };
/*    86 */           log.table(sites, function(row, s) {
/*    87 */             row.cell("Name", s.Name);
/*    88 */             row.cell("State", s.State);
/*    89 */             row.cell("Host names", s.HostNames);
                      });
                    }
/*    91 */          else {
/*    92 */           log.info("No sites created yet. You can create new sites using \"azure site create\" or through the portal.");
                    }
                  ;
                    _();
                  }, true));
                });
              });
/*    96 */   function choose(data, callback) {
/*    97 */     cli.choose(data, function(x) {
/*    97 */       callback(undefined, x);
                });
              };
/*    99 */   function prompt(label, callback) {
/*   100 */     cli.prompt(label, function(x) {
/*   100 */       callback(undefined, x);
                });
              };
/*   102 */   function confirm(label, callback) {
/*   103 */     cli.confirm(label, function(x) {
/*   104 */       if (!x) {
/*   105 */         log.warn("The operation was cancelled by the user");
                  }
                ;
/*   107 */       callback(undefined, x);
                });
              };
/*   110 */   site.confirm = confirm;
/*   112 */   site.command("create [name]").whiteListPowershell().description("Create a new web site").option("-s, --subscription <id>", "use the subscription id").option("--location <location>", "the geographic region to create the website").option("--hostname <hostname>", "custom host name to use").option("--git", "configure git on web site and local folder").execute(function __2(nameArg, options, _) {
                var context;
/*   142 */     function promptForSiteName(_) {
                  var __frame = {
                    name: "promptForSiteName",
                    line: 142
                  };
                  return __func(_, this, arguments, promptForSiteName, 0, __frame, function __$promptForSiteName() {
/*   143 */         log.silly("promptForSiteName");
                    return (function __$promptForSiteName(__then) {
/*   144 */           if ((context.site.name === undefined)) {
/*   145 */             log.help("Need a site name");
/*   146 */             return prompt("Name: ", __cb(_, __frame, 4, 34, function ___(__0, __1) {
/*   146 */               context.site.name = __1;
                          __then();
                        }, true));
                      }
                       else {
                        __then();
                      }
                    ;
                    })(_);
                  });
                };
/*   150 */     function determineIfSiteExists(_) {
                  var sites, hits;
                  var __frame = {
                    name: "determineIfSiteExists",
                    line: 150
                  };
                  return __func(_, this, arguments, determineIfSiteExists, 0, __frame, function __$determineIfSiteExists() {
/*   151 */         log.silly("determineIfSiteExists");
/*   152 */         return site.doSitesGet(context, __cb(_, __frame, 2, 24, function ___(__0, __1) {
                      sites = __1;
/*   153 */           hits = sites.filter(function(item) {
/*   154 */             return utils.ignoreCaseEquals(item.Name, context.site.name);
                      });
/*   156 */           if ((hits.length === 1)) {
/*   157 */             log.info("Updating existing site");
/*   158 */             context.flags.siteExists = true;
/*   159 */             if ((context.site.webspace === undefined)) {
/*   160 */               context.site.webspace = hits[0].WebSpace;
/*   161 */               log.verbose("Existing site location is ", context.site.webspace);
                        }
                         else {
/*   162 */               if ((context.site.webspace !== hits[0].WebSpace)) {
/*   163 */                 return _(new Error(((("Expected location " + context.site.webspace) + " but was ") + hits[0].WebSpace)));
                          }
                        ;
                        }
                      ;
                      }
                    ;
                      _();
                    }, true));
                  });
                };
/*   168 */     function promptForLocation(_) {
                  var spaces, displayNameMatches;
                  var __frame = {
                    name: "promptForLocation",
                    line: 168
                  };
                  return __func(_, this, arguments, promptForLocation, 0, __frame, function __$promptForLocation() {
/*   169 */         log.silly("promptForLocation");
/*   170 */         return cacheUtils.readSpaces(context, __cb(_, __frame, 2, 25, function ___(__0, __1) {
                      spaces = __1;
                      return (function __$promptForLocation(__then) {
/*   171 */             if ((!spaces || !spaces.length)) {
/*   172 */               return site.doSpacesGet(context, __cb(_, __frame, 4, 23, function ___(__0, __2) {
/*   172 */                 spaces = __2;
                            __then();
                          }, true));
                        }
                         else {
                          __then();
                        }
                      ;
                      })(function __$promptForLocation() {
/*   175 */             if ((context.site.webspace !== undefined)) {
/*   177 */               displayNameMatches = spaces.filter(function(space) {
/*   178 */                 return (space.GeoRegion === context.site.webspace);
                          });
/*   181 */               if ((displayNameMatches.length === 1)) {
/*   182 */                 context.site.webspace = displayNameMatches[0].Name;
                          }
                        ;
                        }
                      ;
/*   186 */             if ((context.site.webspace !== undefined)) {
                          return _(null);
                        }
                      ;
                        return (function __$promptForLocation(__then) {
/*   191 */               if ((spaces.length === 0)) {
/*   192 */                 return portalCreateSiteInstruction(context, __cb(_, __frame, 24, 14, function __$promptForLocation() {
/*   193 */                   return _(new Error("First site must be created on portal"));
                            }, true));
                          }
                           else {
                            return (function __$promptForLocation(__then) {
/*   194 */                   if ((spaces.length == 1)) {
/*   195 */                     context.site.webspace = spaces[0].Name;
/*   196 */                     log.info("Using location", spaces[0].GeoRegion);
                                __then();
                              }
                               else {
/*   198 */                     log.help("Choose a region");
/*   199 */                     return choose(spaces.map(function(space) {
/*   200 */                       return space.GeoRegion;
                                }), __cb(_, __frame, 31, 45, function ___(__0, __3) {
/*   199 */                       context.site.webspace = spaces[__3].Name;
                                  __then();
                                }, true));
                              }
                            ;
                            })(__then);
                          }
                        ;
                        })(_);
                      });
                    }, true));
                  });
                };
/*   205 */     function determineIfCurrentDirectoryIsGitWorkingTree(_) {
                  var isInsideWorkTree, lines;
                  var __frame = {
                    name: "determineIfCurrentDirectoryIsGitWorkingTree",
                    line: 205
                  };
                  return __func(_, this, arguments, determineIfCurrentDirectoryIsGitWorkingTree, 0, __frame, function __$determineIfCurrentDirectoryIsGitWorkingTree() {
/*   206 */         log.silly("determineIfCurrentDirectoryIsGitWorkingTree");
                    return (function ___(__then) {
                      (function ___(_) {
                        __tryCatch(_, function __$determineIfCurrentDirectoryIsGitWorkingTree() {
/*   209 */               return exec("git rev-parse --git-dir", __cb(_, __frame, 4, 37, function ___(__0, __1) {
                            isInsideWorkTree = __1;
/*   210 */                 lines = (isInsideWorkTree.stdout + isInsideWorkTree.stderr);
/*   211 */                 context.flags.isGitWorkingTree = lines.split("\n").some(function(line) {
/*   212 */                   return (line === ".git");
                            });
                            __then();
                          }, true));
                        });
                      })(function ___(err, __result) {
                        __tryCatch(_, function __$determineIfCurrentDirectoryIsGitWorkingTree() {
                          if (err) {
/*   215 */                 context.flags.isGitWorkingTree = false;
                            __then();
                          }
                           else {
                            _(null, __result);
                          }
                        ;
                        });
                      });
                    })(function ___() {
                      __tryCatch(_, _);
                    });
                  });
                };
/*   219 */     function initGitOnCurrentDirectory(_) {
                  var __frame = {
                    name: "initGitOnCurrentDirectory",
                    line: 219
                  };
                  return __func(_, this, arguments, initGitOnCurrentDirectory, 0, __frame, function __$initGitOnCurrentDirectory() {
/*   220 */         log.silly("initGitOnCurrentDirectoryIfNeeded");
/*   221 */         if (context.flags.isGitWorkingTree) {
                      return _(null);
                    }
                  ;
/*   225 */         if (!options.git) {
                      return _(null);
                    }
                  ;
/*   229 */         return site.doPublishingUsersGet(context, __cb(_, __frame, 10, 38, function ___(__0, __1) {
/*   229 */           context.publishingUsers = __1;
/*   230 */           return getPublishingUser(context, __cb(_, __frame, 11, 37, function ___(__0, __2) {
/*   230 */             context.publishingUser = __2;
/*   232 */             log.info("Executing `git init`");
/*   233 */             return exec("git init", __cb(_, __frame, 14, 12, function __$initGitOnCurrentDirectory() {
                          return (function __$initGitOnCurrentDirectory(__then) {
/*   235 */                 if (!utils.pathExistsSync(".gitignore")) {
/*   236 */                   log.info("Creating default .gitignore file");
/*   237 */                   return fs.writeFile(".gitignore", "node_modules\nazure_error", __cb(_, __frame, 18, 14, __then, true));
                            }
                             else {
                              __then();
                            }
                          ;
                          })(function __$initGitOnCurrentDirectory() {
/*   240 */                 context.flags.isGitWorkingTree = true;
                            _();
                          });
                        }, true));
                      }, true));
                    }, true));
                  });
                };
/*   243 */     function copyIisNodeWhenServerJsPresent(_) {
                  var sourcePath;
                  var __frame = {
                    name: "copyIisNodeWhenServerJsPresent",
                    line: 243
                  };
                  return __func(_, this, arguments, copyIisNodeWhenServerJsPresent, 0, __frame, function __$copyIisNodeWhenServerJsPresent() {
/*   244 */         log.silly("copyWebConfigWhenServerJsPresent");
                    return (function __$copyIisNodeWhenServerJsPresent(__then) {
/*   245 */           if ((!utils.pathExistsSync("iisnode.yml") && ((utils.pathExistsSync("server.js") || utils.pathExistsSync("app.js"))))) {
/*   246 */             log.info("Creating default iisnode.yml file");
/*   247 */             sourcePath = path.join(__dirname, "../templates/node/iisnode.yml");
/*   248 */             return fs.readFile(sourcePath, __cb(_, __frame, 5, 42, function ___(__0, __1) {
/*   248 */               return fs.writeFile("iisnode.yml", __1, __cb(_, __frame, 5, 14, __then, true));
                        }, true));
                      }
                       else {
                        __then();
                      }
                    ;
                    })(_);
                  });
                };
/*   252 */     function updateLocalConfigWithSiteName(_) {
                  var cfg;
                  var __frame = {
                    name: "updateLocalConfigWithSiteName",
                    line: 252
                  };
                  return __func(_, this, arguments, updateLocalConfigWithSiteName, 0, __frame, function __$updateLocalConfigWithSiteName() {
/*   253 */         log.silly("updateLocalConfigWithSiteName");
                    return (function __$updateLocalConfigWithSiteName(__then) {
/*   254 */           if (context.flags.isGitWorkingTree) {
/*   255 */             return site.readConfig(__cb(_, __frame, 3, 24, function ___(__0, __1) {
                          cfg = __1;
/*   256 */               cfg.name = context.site.name;
/*   257 */               cfg.webspace = context.site.webspace;
/*   258 */               return site.writeConfig(cfg, __cb(_, __frame, 6, 14, __then, true));
                        }, true));
                      }
                       else {
                        __then();
                      }
                    ;
                    })(_);
                  });
                };
/*   262 */     function createSiteAndInitializeRemoteRepo(_) {
                  var __frame = {
                    name: "createSiteAndInitializeRemoteRepo",
                    line: 262
                  };
                  return __func(_, this, arguments, createSiteAndInitializeRemoteRepo, 0, __frame, function __$createSiteAndInitializeRemoteRepo() {
/*   263 */         log.silly("createSiteAndInitializeRemoteRepo");
                    return (function __$createSiteAndInitializeRemoteRepo(__then) {
/*   264 */           if (!context.flags.siteExists) {
/*   265 */             return site.doSitesPost(context, __cb(_, __frame, 3, 14, function __$createSiteAndInitializeRemoteRepo() {
/*   266 */               return site.doRepositoryPost(context, __cb(_, __frame, 4, 14, function __$createSiteAndInitializeRemoteRepo() {
/*   267 */                 return site.doRepositoryGet(context, __cb(_, __frame, 5, 29, function ___(__0, __1) {
/*   267 */                   context.repo = __1;
                              __then();
                            }, true));
                          }, true));
                        }, true));
                      }
                       else {
/*   269 */             return site.doRepositoryGet(context, __cb(_, __frame, 7, 29, function ___(__0, __2) {
/*   269 */               context.repo = __2;
                          return (function __$createSiteAndInitializeRemoteRepo(__then) {
/*   270 */                 if (!context.repo) {
/*   271 */                   return site.doRepositoryPost(context, __cb(_, __frame, 9, 16, function __$createSiteAndInitializeRemoteRepo() {
/*   272 */                     return site.doRepositoryGet(context, __cb(_, __frame, 10, 31, function ___(__0, __3) {
/*   272 */                       context.repo = __3;
                                  __then();
                                }, true));
                              }, true));
                            }
                             else {
                              __then();
                            }
                          ;
                          })(__then);
                        }, true));
                      }
                    ;
                    })(function __$createSiteAndInitializeRemoteRepo() {
/*   275 */           log.silly("context.repo", context.repo);
                      _();
                    });
                  });
                };
/*   278 */     function addRemoteToLocalGitRepo(_) {
                  var remotes, azureExists, gitUri;
                  var __frame = {
                    name: "addRemoteToLocalGitRepo",
                    line: 278
                  };
                  return __func(_, this, arguments, addRemoteToLocalGitRepo, 0, __frame, function __$addRemoteToLocalGitRepo() {
/*   279 */         log.silly("addRemoteToLocalGitRepo");
/*   280 */         if (!context.flags.isGitWorkingTree) {
/*   281 */           log.info((("To create a local git repository to publish to the remote site, please rerun this command with the --git flag: \"azure site create " + ((((context.site && context.site.name)) || "{site name}"))) + " --git\"."));
                      return _(null);
                    }
                  ;
                    return (function __$addRemoteToLocalGitRepo(__then) {
/*   285 */           if (!context.publishingUser) {
/*   286 */             return site.doPublishingUsersGet(context, __cb(_, __frame, 8, 40, function ___(__0, __1) {
/*   286 */               context.publishingUsers = __1;
/*   287 */               return getPublishingUser(context, __cb(_, __frame, 9, 39, function ___(__0, __2) {
/*   287 */                 context.publishingUser = __2;
                            __then();
                          }, true));
                        }, true));
                      }
                       else {
                        __then();
                      }
                    ;
                    })(function __$addRemoteToLocalGitRepo() {
/*   290 */           log.verbose("Detecting git and local git folder");
/*   291 */           return exec("git remote", __cb(_, __frame, 13, 26, function ___(__0, __3) {
                        remotes = __3;
/*   292 */             azureExists = ((remotes.stdout + remotes.stderr)).split("\n").some(function(item) {
/*   293 */               return (item === "azure");
                        });
                        return (function __$addRemoteToLocalGitRepo(__then) {
/*   296 */               if (azureExists) {
/*   297 */                 log.verbose("Removing existing azure remote alias");
/*   298 */                 return exec("git remote rm azure", __cb(_, __frame, 20, 14, __then, true));
                          }
                           else {
                            __then();
                          }
                        ;
                        })(function __$addRemoteToLocalGitRepo() {
/*   301 */               gitUri = getGitUri(context.repo, context.site.name, context.publishingUser);
/*   302 */               log.info((("Executing `git remote add azure " + gitUri) + "`"));
/*   303 */               return exec(("git remote add azure " + gitUri), __cb(_, __frame, 25, 12, _, true));
                        });
                      }, true));
                    });
                  });
                };
                var __frame = {
                  name: "__2",
                  line: 119
                };
                return __func(_, this, arguments, __2, 2, __frame, function __$__2() {
/*   120 */       context = {
/*   121 */         subscription: cli.category("account").lookupSubscriptionId(options.subscription),
/*   122 */         git: options.git,
/*   123 */         site: {
/*   124 */           name: nameArg,
/*   125 */           webspace: options.location,
/*   126 */           hostname: options.hostname
                    },
/*   128 */         flags: {
                    }
                  };
/*   132 */       return promptForSiteName(__cb(_, __frame, 13, 10, function __$__2() {
/*   133 */         return determineIfSiteExists(__cb(_, __frame, 14, 10, function __$__2() {
/*   134 */           return promptForLocation(__cb(_, __frame, 15, 10, function __$__2() {
/*   135 */             return determineIfCurrentDirectoryIsGitWorkingTree(__cb(_, __frame, 16, 10, function __$__2() {
/*   136 */               return initGitOnCurrentDirectory(__cb(_, __frame, 17, 10, function __$__2() {
/*   137 */                 return copyIisNodeWhenServerJsPresent(__cb(_, __frame, 18, 10, function __$__2() {
/*   138 */                   return updateLocalConfigWithSiteName(__cb(_, __frame, 19, 10, function __$__2() {
/*   139 */                     return createSiteAndInitializeRemoteRepo(__cb(_, __frame, 20, 10, function __$__2() {
/*   140 */                       return addRemoteToLocalGitRepo(__cb(_, __frame, 21, 10, _, true));
                                }, true));
                              }, true));
                            }, true));
                          }, true));
                        }, true));
                      }, true));
                    }, true));
                  }, true));
                });
              });
/*   307 */   function portalCreateSiteInstruction(context, _) {
                var href;
                var __frame = {
                  name: "portalCreateSiteInstruction",
                  line: 307
                };
                return __func(_, this, arguments, portalCreateSiteInstruction, 1, __frame, function __$portalCreateSiteInstruction() {
/*   308 */       log.help("You must create your first web site using the Windows Azure portal.");
/*   309 */       log.help("Please follow these steps in the portal:");
/*   310 */       log.help("1. At the bottom of the page, click on New > Web Site > Quick Create");
/*   311 */       log.help((("2. Type \"" + ((((context.site && context.site.name)) || "{site name}"))) + "\" in the URL field"));
/*   312 */       log.help("3. Click on \"Create Web Site\"");
/*   313 */       log.help("4. Once the site has been created, click on the site name");
/*   314 */       log.help("5. Click on \"Set up Git publishing\" or \"Reset deployment credentials\" and setup a publishing username and password. Use those credentials for all new websites you create.");
/*   315 */       if (context.git) {
/*   316 */         log.help("6. Back in the console window, rerun this command by typing \"azure site create {site name} --git\"");
                  }
                ;
/*   319 */       return confirm("Launch browser to portal now? (y/n) ", __cb(_, __frame, 12, 8, function ___(__0, __1) {
                    return (function __$portalCreateSiteInstruction(__then) {
                      if (__1) {
/*   320 */             log.help("Launching portal.");
/*   321 */             href = utils.getPortalUrl();
/*   322 */             common.launchBrowser(href);
                        __then();
                      }
                       else {
                        __then();
                      }
                    ;
                    })(_);
                  }, true));
                });
              };
/*   326 */   function getPublishingUser(context, _) {
                var publishingUsers, filters;
                var __frame = {
                  name: "getPublishingUser",
                  line: 326
                };
                return __func(_, this, arguments, getPublishingUser, 1, __frame, function __$getPublishingUser() {
/*   327 */       publishingUsers = toArray(context.publishingUsers);
/*   328 */       filters = publishingUsers.filter(function(item) {
/*   329 */         return ((typeof item === "string") && (item.length <= 64));
                  });
                  return (function __$getPublishingUser(__then) {
/*   332 */         if ((filters.length === 0)) {
/*   333 */           return portalGitInitInstruction(context, __cb(_, __frame, 7, 6, function __$getPublishingUser() {
/*   334 */             return _(new Error("Git credentials needs to be setup on the portal"));
                      }, true));
                    }
                     else {
/*   335 */           if (((publishingUsers.length === 1) && (filters.length === 1))) {
/*   336 */             return _(null, filters[0]);
                      }
                    ;
                      __then();
                    }
                  ;
                  })(function __$getPublishingUser() {
/*   339 */         log.help("Please provide the username for Git deployment.");
/*   340 */         log.help("If you don't have one, please configure it in the management portal.");
/*   341 */         return prompt("Publishing username: ", __cb(_, __frame, 15, 11, _, true));
                  });
                });
              };
/*   344 */   function portalGitInitInstruction(context, _) {
                var href;
                var __frame = {
                  name: "portalGitInitInstruction",
                  line: 344
                };
                return __func(_, this, arguments, portalGitInitInstruction, 1, __frame, function __$portalGitInitInstruction() {
/*   345 */       log.help("You must create your git publishing credentials using the Windows Azure portal.");
/*   346 */       log.help("Please follow these steps in the portal:");
/*   347 */       log.help("1. In the menu on the left select \"Web Sites\"");
/*   348 */       log.help((("2. Click on the site named \"" + ((((context.site && context.site.name)) || "{site name}"))) + "\" or any other site"));
/*   349 */       log.help("3. Click on \"Set up Git publishing\" or \"Reset deployment credentials\" and setup a publishing username and password. Use those credentials for all new websites you create.");
/*   350 */       if (context.git) {
/*   351 */         log.help("4. Back in the console window, rerun this command by typing \"azure site create {site name} --git\"");
                  }
                ;
/*   354 */       return confirm("Launch browser to portal now? (y/n) ", __cb(_, __frame, 10, 8, function ___(__0, __1) {
                    return (function __$portalGitInitInstruction(__then) {
                      if (__1) {
/*   355 */             log.help("Launching portal.");
/*   356 */             href = utils.getPortalUrl();
/*   357 */             common.launchBrowser(href);
                        __then();
                      }
                       else {
                        __then();
                      }
                    ;
                    })(_);
                  }, true));
                });
              };
/*   361 */   var location = site.category("location").description("Commands to manage your Azure locations");
/*   364 */   location.command("list").whiteListPowershell().description("List locations available for your account").execute(function __3(options, _) {
                var context, spaces, s;
                var __frame = {
                  name: "__3",
                  line: 367
                };
                return __func(_, this, arguments, __3, 1, __frame, function __$__3() {
/*   368 */       context = {
/*   369 */         subscription: cli.category("account").lookupSubscriptionId(options.subscription)
                  };
/*   372 */       return site.doSpacesGet(context, __cb(_, __frame, 5, 23, function ___(__0, __1) {
                    spaces = __1;
                    return (function __$__3(__then) {
/*   373 */           if ((spaces && spaces.length)) {
/*   374 */             for (s in spaces) {
/*   375 */               spaces[s] = clean(spaces[s]);
                        };
/*   378 */             log.table(spaces, function(row, item) {
/*   379 */               row.cell("Name", item.GeoRegion);
                        });
                        __then();
                      }
                       else {
/*   382 */             return portalCreateSiteInstruction(context, __cb(_, __frame, 15, 12, __then, true));
                      }
                    ;
                    })(_);
                  }, true));
                });
              });
/*   386 */   site.command("portal [name]").whiteListPowershell().description("Opens the portal in a browser to manage your web sites").execute(function __4(name, options, _) {
                var href;
                var __frame = {
                  name: "__4",
                  line: 389
                };
                return __func(_, this, arguments, __4, 2, __frame, function __$__4() {
/*   391 */       href = utils.getPortalUrl();
/*   392 */       if (name) {
/*   393 */         href = (((href + "#Workspaces/WebsiteExtension/Website/") + name) + "/dashboard");
                  }
                ;
/*   396 */       common.launchBrowser(href);
                  _();
                });
              });
/*   399 */   site.command("browse [name]").whiteListPowershell().description("Open your web site in a browser.").option("-s, --subscription <id>", "use the subscription id").execute(function __5(name, options, _) {
                var context, cache, siteData, href;
                var __frame = {
                  name: "__5",
                  line: 403
                };
                return __func(_, this, arguments, __5, 2, __frame, function __$__5() {
/*   405 */       context = {
/*   406 */         subscription: cli.category("account").lookupSubscriptionId(options.subscription),
/*   407 */         site: {
/*   408 */           name: name
                    }
                  };
/*   412 */       return lookupSiteNameAndWebSpace(context, __cb(_, __frame, 9, 22, function ___(__0, __2) {
                    cache = __2;
                    return (function __$__5(_) {
/*   413 */           var __1 = cache;
                      if (__1) {
                        return _(null, __1);
                      }
                    ;
/*   413 */           return site.doSiteGet(context, __cb(_, __frame, 10, 40, _, true));
                    })(__cb(_, __frame, -402, 17, function ___(__0, __3) {
/*   413 */           siteData = clean(__3);
/*   415 */           href = ("http://" + toArray(siteData.HostNames)[0]);
/*   417 */           common.launchBrowser(href);
                      _();
                    }, true));
                  }, true));
                });
              });
/*   420 */   site.command("show [name]").whiteListPowershell().description("Show details for a web site").option("-s, --subscription <id>", "use the subscription id").execute(function __6(name, options, _) {
                var context, result, repositoryUri, gitUri, data;
                var __frame = {
                  name: "__6",
                  line: 424
                };
                return __func(_, this, arguments, __6, 2, __frame, function __$__6() {
/*   425 */       context = {
/*   426 */         subscription: cli.category("account").lookupSubscriptionId(options.subscription),
/*   427 */         site: {
/*   428 */           name: name
                    }
                  };
/*   432 */       return lookupSiteNameAndWebSpace(context, __cb(_, __frame, 8, 10, function __$__6() {
/*   434 */         log.info("Showing details for site");
/*   435 */         log.verbose("Parameters", context);
/*   437 */         return async.parallel([function __1(_) {
                      var __frame = {
                        name: "__1",
                        line: 438
                      };
                      return __func(_, this, arguments, __1, 0, __frame, function __$__1() {
/*   438 */             return site.doSiteGet(context, __cb(_, __frame, 0, 34, _, true));
                      });
/*   439 */         },function __2(_) {
                      var __frame = {
                        name: "__2",
                        line: 439
                      };
                      return __func(_, this, arguments, __2, 0, __frame, function __$__2() {
/*   439 */             return site.doSiteConfigGet(context, __cb(_, __frame, 0, 34, _, true));
                      });
                    },], __cb(_, __frame, 13, 23, function ___(__0, __3) {
                      result = __3;
/*   443 */           repositoryUri = getRepositoryUri(result[0]);
/*   444 */           gitUri = (repositoryUri ? getGitUri(repositoryUri, context.site.name) : "none");
/*   446 */           if (log.format().json) {
/*   447 */             data = {
/*   448 */               site: clean(result[0]),
/*   449 */               config: clean(result[1]),
/*   450 */               gitRepositoryUri: gitUri
                        };
/*   453 */             log.json(data);
                      }
/*   454 */            else {
/*   455 */             logEachData("Site", result[0]);
/*   456 */             logEachData("Config", result[1]);
/*   458 */             log.data("GitRepositoryUri", gitUri);
                      }
                    ;
                      _();
                    }, true));
                  }, true));
                });
              });
/*   462 */   function lookupSiteName(context, _) {
                var cfg;
                var __frame = {
                  name: "lookupSiteName",
                  line: 462
                };
                return __func(_, this, arguments, lookupSiteName, 1, __frame, function __$lookupSiteName() {
/*   463 */       if ((context.site.name !== undefined)) {
                    return _(null);
                  }
                ;
/*   468 */       return site.readConfig(__cb(_, __frame, 6, 14, function ___(__0, __1) {
                    cfg = __1;
/*   469 */         if ((cfg && cfg.name)) {
/*   471 */           context.site.name = cfg.name;
/*   472 */           context.site.webspace = cfg.webspace;
                      return _(null);
                    }
                  ;
/*   476 */         return prompt("Web site name: ", __cb(_, __frame, 14, 24, function ___(__0, __2) {
/*   476 */           context.site.name = __2;
/*   478 */           if (!context.site.name) {
/*   479 */             return _(new Error("Invalid site name"));
                      }
                    ;
                      _();
                    }, true));
                  }, true));
                });
              };
/*   483 */   function lookupSiteWebSpace(context, _) {
                var sites, index;
                var __frame = {
                  name: "lookupSiteWebSpace",
                  line: 483
                };
                return __func(_, this, arguments, lookupSiteWebSpace, 1, __frame, function __$lookupSiteWebSpace() {
/*   484 */       log.verbose("Attempting to locate site ", context.site.name);
/*   485 */       return site.doSitesGet(context, __cb(_, __frame, 2, 16, function ___(__0, __1) {
                    sites = __1;
/*   486 */         for (index in sites) {
/*   487 */           if (utils.ignoreCaseEquals(sites[index].Name, context.site.name)) {
/*   488 */             log.verbose("Site located at ", sites[index].WebSpace);
/*   489 */             context.site.webspace = sites[index].WebSpace;
                      }
                    ;
                    };
/*   492 */         if ((context.site.webspace === undefined)) {
/*   493 */           return _(new Error(("Unable to locate site named " + context.site.name)));
                    }
                  ;
                    _();
                  }, true));
                });
              };
/*   497 */   function lookupSiteNameAndWebSpace(context, _) {
                var cache;
                var __frame = {
                  name: "lookupSiteNameAndWebSpace",
                  line: 497
                };
                return __func(_, this, arguments, lookupSiteNameAndWebSpace, 1, __frame, function __$lookupSiteNameAndWebSpace() {
/*   498 */       return lookupSiteName(context, __cb(_, __frame, 1, 4, function __$lookupSiteNameAndWebSpace() {
/*   499 */         return cacheUtils.readSite(context, __cb(_, __frame, 2, 16, function ___(__0, __1) {
                      cache = __1;
/*   500 */           if ((cache || context.site.webspace)) {
/*   501 */             context.site.webspace = (((cache && cache.WebSpace)) || context.site.webspace);
/*   502 */             return _(null, cache);
                      }
                    ;
/*   504 */           return lookupSiteWebSpace(context, __cb(_, __frame, 7, 4, _, true));
                    }, true));
                  }, true));
                });
              };
/*   507 */   site.lookupSiteNameAndWebSpace = lookupSiteNameAndWebSpace;
/*   509 */   function getRepositoryUri(siteData) {
/*   510 */     if (siteData.SiteProperties.Properties) {
/*   511 */       for (var i = 0; (i < siteData.SiteProperties.Properties.NameValuePair.length); ++i) {
/*   512 */         var pair = siteData.SiteProperties.Properties.NameValuePair[i];
/*   513 */         if (utils.ignoreCaseEquals(pair.Name, "RepositoryUri")) {
/*   514 */           if ((typeof pair.Value === "string")) {
/*   515 */             if (!endsWith(pair.Value, "/")) {
/*   517 */               pair.Value += "/";
                        }
                      ;
/*   520 */             return pair.Value;
                      }
/*   521 */            else {
/*   522 */             return null;
                      }
                    ;
                    }
                  ;
                  };
                }
              ;
/*   528 */     return null;
              };
/*   531 */   site.getRepositoryUri = getRepositoryUri;
/*   533 */   function getGitUri(repositoryUri, siteName, auth) {
/*   534 */     var repoUrl = url.parse(repositoryUri);
/*   536 */     if (auth) {
/*   537 */       repoUrl.auth = auth;
                }
              ;
/*   540 */     var sitePath = (siteName + ".git");
/*   542 */     if (!endsWith(repoUrl.path, "/")) {
/*   544 */       repoUrl.path += "/";
                }
              ;
/*   546 */     repoUrl.path += sitePath;
/*   548 */     if (!endsWith(repoUrl.pathname, "/")) {
/*   550 */       repoUrl.pathname += "/";
                }
              ;
/*   552 */     repoUrl.pathname += sitePath;
/*   554 */     return url.format(repoUrl);
              };
/*   557 */   function getRepositoryAuth(siteData) {
/*   558 */     var userName, password;
/*   559 */     for (var i = 0; (i < siteData.SiteProperties.Properties.NameValuePair.length); ++i) {
/*   560 */       var pair = siteData.SiteProperties.Properties.NameValuePair[i];
/*   561 */       if (utils.ignoreCaseEquals(pair.Name, "PublishingUsername")) {
/*   562 */         userName = pair.Value;
                  }
/*   563 */        else if (utils.ignoreCaseEquals(pair.Name, "PublishingPassword")) {
/*   564 */         password = pair.Value;
                  }
                  
                ;
                };
/*   567 */     return (userName && (((userName + ":") + password)));
              };
/*   569 */   site.getRepositoryAuth = getRepositoryAuth;
/*   571 */   site.command("delete [name]").whiteListPowershell().description("Delete a web site").option("-s, --subscription <id>", "use the subscription id").option("-q, --quiet", "quiet mode, do not ask for delete confirmation").execute(function __7(name, options, _) {
                var context, progress, result;
                var __frame = {
                  name: "__7",
                  line: 576
                };
                return __func(_, this, arguments, __7, 2, __frame, function __$__7() {
/*   577 */       context = {
/*   578 */         subscription: cli.category("account").lookupSubscriptionId(options.subscription),
/*   579 */         site: {
/*   580 */           name: name
                    }
                  };
/*   584 */       return lookupSiteNameAndWebSpace(context, __cb(_, __frame, 8, 10, function __$__7() {
/*   586 */         log.info("Deleting site", context.site.name);
                    return (function __$__7(_) {
/*   587 */           var __1 = !options.quiet;
                      if (!__1) {
                        return _(null, __1);
                      }
                    ;
/*   587 */           return confirm((("Delete " + context.site.name) + " site?  (y/n) "), __cb(_, __frame, 11, 33, function ___(__0, __3) {
/*   587 */             var __2 = !__3;
                        return _(null, __2);
                      }, true));
                    })(__cb(_, __frame, -575, 17, function ___(__0, __2) {
                      return (function __$__7(__then) {
                        if (__2) {
                          return _(null);
                        }
                         else {
                          __then();
                        }
                      ;
                      })(function __$__7() {
/*   591 */             progress = cli.progress("Deleting site");
                        return (function ___(__then) {
                          (function ___(_) {
                            __tryCatch(_, function __$__7() {
/*   600 */                   return getChannel().path(context.subscription).path("services").path("webspaces").path(context.site.webspace).path("sites").path(context.site.name).DELETE(__cb(_, __frame, 24, 25, function ___(__0, __3) {
                                result = __3;
/*   601 */                     return cacheUtils.deleteSite(context, __cb(_, __frame, 25, 12, function __$__7() {
                                  _(null, null, true);
                                }, true));
                              }, true));
                            });
                          })(function ___(__e, __r, __cont) {
                            (function ___(__then) {
                              __tryCatch(_, function __$__7() {
/*   604 */                     progress.end();
                                __then();
                              });
                            })(function ___() {
                              __tryCatch(_, function ___() {
                                if (__cont) {
                                  __then();
                                } else {
                                  _(__e, __r);
                                };
                              });
                            });
                          });
                        })(function ___() {
                          __tryCatch(_, function __$__7() {
/*   606 */                 log.info((("Site " + context.site.name) + " has been deleted"));
                            _();
                          });
                        });
                      });
                    }, true));
                  }, true));
                });
              });
/*   610 */   site.command("start [name]").whiteListPowershell().description("Start a web site").option("-s, --subscription <id>", "use the subscription id").execute(function __8(name, options, _) {
                var context, progress, result;
                var __frame = {
                  name: "__8",
                  line: 614
                };
                return __func(_, this, arguments, __8, 2, __frame, function __$__8() {
/*   615 */       context = {
/*   616 */         subscription: cli.category("account").lookupSubscriptionId(options.subscription),
/*   617 */         site: {
/*   618 */           name: name
                    }
                  };
/*   622 */       return lookupSiteNameAndWebSpace(context, __cb(_, __frame, 8, 10, function __$__8() {
/*   624 */         log.info("Starting site", context.site.name);
/*   626 */         progress = cli.progress("Updating site state");
                    return (function ___(__then) {
                      (function ___(_) {
                        __tryCatch(_, function __$__8() {
/*   636 */               return getChannel().path(context.subscription).path("services").path("webspaces").path(context.site.webspace).path("sites").path(context.site.name).header("Content-Type", "application/xml").PUT(function(req) {
/*   637 */                 req.write("<Site xmlns=\"http://schemas.microsoft.com/windowsazure\">");
/*   638 */                 req.write("<HostNames>");
/*   639 */                 req.write("<string xmlns=\"http://schemas.microsoft.com/2003/10/Serialization/Arrays\">");
/*   640 */                 req.write((context.site.name + utils.getHostNameSuffix()));
/*   641 */                 req.write("</string>");
/*   642 */                 req.write("</HostNames>");
/*   643 */                 req.write("<Name>");
/*   644 */                 req.write(context.site.name);
/*   645 */                 req.write("</Name>");
/*   646 */                 req.write("<State>");
/*   647 */                 req.write("Running");
/*   648 */                 req.write("</State>");
/*   649 */                 req.write("</Site>");
/*   651 */                 req.end();
                          }, __cb(_, __frame, 22, 25, function ___(__0, __1) {
                            result = __1;
                            _(null, null, true);
                          }, true));
                        });
                      })(function ___(__e, __r, __cont) {
                        (function ___(__then) {
                          __tryCatch(_, function __$__8() {
/*   655 */                 progress.end();
                            __then();
                          });
                        })(function ___() {
                          __tryCatch(_, function ___() {
                            if (__cont) {
                              __then();
                            } else {
                              _(__e, __r);
                            };
                          });
                        });
                      });
                    })(function ___() {
                      __tryCatch(_, function __$__8() {
/*   658 */             log.info((("Site " + context.site.name) + " has been started"));
                        _();
                      });
                    });
                  }, true));
                });
              });
/*   661 */   site.command("stop [name]").whiteListPowershell().description("Stop a web site").option("-s, --subscription <id>", "use the subscription id").execute(function __9(name, options, _) {
                var context, progress, result;
                var __frame = {
                  name: "__9",
                  line: 665
                };
                return __func(_, this, arguments, __9, 2, __frame, function __$__9() {
/*   666 */       context = {
/*   667 */         subscription: cli.category("account").lookupSubscriptionId(options.subscription),
/*   668 */         site: {
/*   669 */           name: name
                    }
                  };
/*   673 */       return lookupSiteNameAndWebSpace(context, __cb(_, __frame, 8, 10, function __$__9() {
/*   675 */         log.info("Stopping site", context.site.name);
/*   677 */         progress = cli.progress("Updating site state");
                    return (function ___(__then) {
                      (function ___(_) {
                        __tryCatch(_, function __$__9() {
/*   687 */               return getChannel().path(context.subscription).path("services").path("webspaces").path(context.site.webspace).path("sites").path(context.site.name).header("Content-Type", "application/xml").PUT(function(req) {
/*   688 */                 req.write("<Site xmlns=\"http://schemas.microsoft.com/windowsazure\">");
/*   689 */                 req.write("<HostNames>");
/*   690 */                 req.write("<string xmlns=\"http://schemas.microsoft.com/2003/10/Serialization/Arrays\">");
/*   691 */                 req.write((context.site.name + utils.getHostNameSuffix()));
/*   692 */                 req.write("</string>");
/*   693 */                 req.write("</HostNames>");
/*   694 */                 req.write("<Name>");
/*   695 */                 req.write(context.site.name);
/*   696 */                 req.write("</Name>");
/*   697 */                 req.write("<State>");
/*   698 */                 req.write("Stopped");
/*   699 */                 req.write("</State>");
/*   700 */                 req.write("</Site>");
/*   702 */                 req.end();
                          }, __cb(_, __frame, 22, 25, function ___(__0, __1) {
                            result = __1;
                            _(null, null, true);
                          }, true));
                        });
                      })(function ___(__e, __r, __cont) {
                        (function ___(__then) {
                          __tryCatch(_, function __$__9() {
/*   706 */                 progress.end();
                            __then();
                          });
                        })(function ___() {
                          __tryCatch(_, function ___() {
                            if (__cont) {
                              __then();
                            } else {
                              _(__e, __r);
                            };
                          });
                        });
                      });
                    })(function ___() {
                      __tryCatch(_, function __$__9() {
/*   709 */             log.info((("Site " + context.site.name) + " has been stopped"));
                        _();
                      });
                    });
                  }, true));
                });
              });
/*   716 */   site.readConfig = function site_readConfig__10(_) {
                var __frame = {
                  name: "site_readConfig__10",
                  line: 716
                };
                return __func(_, this, arguments, site_readConfig__10, 0, __frame, function __$site_readConfig__10() {
/*   718 */       return site.readConfigValue("azure.site.name", __cb(_, __frame, 2, 12, function ___(__0, __2) {
/*   719 */         return site.readConfigValue("azure.site.webspace", __cb(_, __frame, 3, 16, function ___(__0, __3) {
/*   717 */           var __1 = {
/*   718 */             name: __2,
/*   719 */             webspace: __3
                      };
                      return _(null, __1);
                    }, true));
                  }, true));
                });
              };
/*   723 */   site.writeConfig = function site_writeConfig__11(cfg, _) {
                var __frame = {
                  name: "site_writeConfig__11",
                  line: 723
                };
                return __func(_, this, arguments, site_writeConfig__11, 1, __frame, function __$site_writeConfig__11() {
/*   724 */       return site.writeConfigValue("azure.site.name", cfg.name, __cb(_, __frame, 1, 4, function __$site_writeConfig__11() {
/*   725 */         return site.writeConfigValue("azure.site.webspace", cfg.webspace, __cb(_, __frame, 2, 4, _, true));
                  }, true));
                });
              };
/*   728 */   site.readConfigValue = function site_readConfigValue__12(name, _) {
                var result;
                var __frame = {
                  name: "site_readConfigValue__12",
                  line: 728
                };
                return __func(_, this, arguments, site_readConfigValue__12, 1, __frame, function __$site_readConfigValue__12() {
                  return (function ___(__then) {
                    (function ___(_) {
                      __tryCatch(_, function __$site_readConfigValue__12() {
/*   730 */             return exec(("git config --get " + name), __cb(_, __frame, 2, 19, function ___(__0, __1) {
                          result = __1;
/*   731 */               return _(null, ((result.stdout + result.stderr)).trim());
                        }, true));
                      });
                    })(function ___(err, __result) {
                      __tryCatch(_, function __$site_readConfigValue__12() {
                        if (err) {
/*   734 */               log.silly("Unable to read config", err);
/*   735 */               return _(null, "");
                        }
                         else {
                          _(null, __result);
                        }
                      ;
                      });
                    });
                  })(function ___() {
                    __tryCatch(_, _);
                  });
                });
              };
/*   739 */   site.writeConfigValue = function site_writeConfigValue__13(name, value, _) {
                var __frame = {
                  name: "site_writeConfigValue__13",
                  line: 739
                };
                return __func(_, this, arguments, site_writeConfigValue__13, 2, __frame, function __$site_writeConfigValue__13() {
/*   740 */       return exec(((("git config " + name) + " ") + value), __cb(_, __frame, 1, 4, _, true));
                });
              };
/*   747 */   site.doSitesPost = function(options, callback) {
/*   748 */     log.info((("Creating a new web site at " + options.site.name) + utils.getHostNameSuffix()));
/*   749 */     log.verbose("Subscription", options.subscription);
/*   750 */     log.verbose("Webspace", options.site.webspace);
/*   751 */     log.verbose("Site", options.site.name);
/*   753 */     var progress = cli.progress("Sending site information");
/*   754 */     getChannel().path(options.subscription).path("services").path("webspaces").path(options.site.webspace).path("sites").header("Content-Type", "application/xml").POST(writers.Site.xml(options.site), function(err, result) {
/*   764 */       progress.end();
/*   765 */       if (err) {
/*   766 */         logError("Failed to create site", err);
                  }
/*   767 */        else {
/*   768 */         return cacheUtils.saveSite(options, result, function(err) {
/*   769 */           log.info(("Created website at " + clean(result).HostNames));
/*   770 */           log.verbose("Site", clean(result));
/*   771 */           return callback(err, result);
                    });
                  }
                ;
/*   775 */       if ((err && (typeof err.Message !== "string"))) {
/*   776 */         return callback("Invalid service request", result);
                  }
/*   777 */        else {
/*   778 */         return callback(err, result);
                  }
                ;
                });
              };
/*   783 */   site.doRepositoryPost = function(options, callback) {
/*   784 */     log.info("Initializing remote Azure repository");
/*   785 */     log.verbose("Subscription", options.subscription);
/*   786 */     log.verbose("Webspace", options.site.webspace);
/*   787 */     log.verbose("Site", options.site.name);
/*   789 */     var progress = cli.progress("Updating site information");
/*   790 */     getChannel().path(options.subscription).path("services").path("webspaces").path(options.site.webspace).path("sites").path(options.site.name).path("repository").POST("", function(err, result) {
/*   801 */       progress.end();
/*   802 */       if (err) {
/*   803 */         logError("Failed to initialize repository", err);
                  }
/*   804 */        else {
/*   805 */         log.info("Repository initialized");
                  }
                ;
/*   807 */       return callback(err, result);
                });
              };
/*   811 */   site.doSpacesGet = function site_doSpacesGet__14(options, _) {
                var progress, result, spaces;
                var __frame = {
                  name: "site_doSpacesGet__14",
                  line: 811
                };
                return __func(_, this, arguments, site_doSpacesGet__14, 1, __frame, function __$site_doSpacesGet__14() {
/*   812 */       log.verbose("Subscription", options.subscription);
/*   814 */       progress = cli.progress("Enumerating locations");
                  return (function ___(__then) {
                    (function ___(_) {
                      __tryCatch(_, function __$site_doSpacesGet__14() {
/*   821 */             return getChannel().path(options.subscription).path("services").path("webspaces").path("").GET(__cb(_, __frame, 10, 19, function ___(__0, __1) {
                          result = __1;
/*   823 */               log.json("silly", result);
/*   824 */               spaces = toArray(result.WebSpace);
/*   825 */               return cacheUtils.saveSpaces(options, spaces, __cb(_, __frame, 14, 6, function __$site_doSpacesGet__14() {
/*   826 */                 return _(null, spaces);
                          }, true));
                        }, true));
                      });
                    })(function ___(__e, __r, __cont) {
                      (function ___(__then) {
                        __tryCatch(_, function __$site_doSpacesGet__14() {
/*   829 */               progress.end();
                          __then();
                        });
                      })(function ___() {
                        __tryCatch(_, function ___() {
                          if (__cont) {
                            __then();
                          } else {
                            _(__e, __r);
                          };
                        });
                      });
                    });
                  })(function ___() {
                    __tryCatch(_, _);
                  });
                });
              };
/*   833 */   site.doSitesGet = function site_doSitesGet__15(options, _) {
                var spaces, channel, progress, result, sites;
                var __frame = {
                  name: "site_doSitesGet__15",
                  line: 833
                };
                return __func(_, this, arguments, site_doSitesGet__15, 1, __frame, function __$site_doSitesGet__15() {
/*   834 */       log.verbose("Subscription", options.subscription);
/*   836 */       return site.doSpacesGet(options, __cb(_, __frame, 3, 17, function ___(__0, __2) {
                    spaces = __2;
/*   841 */         channel = getChannel().path(options.subscription).path("services").path("webspaces");
/*   843 */         progress = cli.progress("Enumerating sites");
                    return (function ___(__then) {
                      (function ___(_) {
                        __tryCatch(_, function __$site_doSitesGet__15() {
/*   845 */               return async.map(spaces, function __1(webspace, _) {
                            var __frame = {
                              name: "__1",
                              line: 847
                            };
                            return __func(_, this, arguments, __1, 1, __frame, function __$__1() {
/*   853 */                   return channel.path(webspace.Name).path("sites").path("").query("propertiesToInclude", "repositoryuri,publishingpassword,publishingusername").GET(__cb(_, __frame, 6, 25, _, true));
                            });
                          }, __cb(_, __frame, 12, 19, function ___(__0, __3) {
                            result = __3;
/*   857 */                 sites = [];
/*   858 */                 result.forEach(function(item) {
/*   859 */                   sites = sites.concat(toArray(item.Site));
                            });
/*   861 */                 result = sites;
/*   863 */                 log.json("verbose", sites);
/*   864 */                 return cacheUtils.saveSites(options, result, __cb(_, __frame, 31, 6, function __$site_doSitesGet__15() {
/*   865 */                   return _(null, sites);
                            }, true));
                          }, true));
                        });
                      })(function ___(__e, __r, __cont) {
                        (function ___(__then) {
                          __tryCatch(_, function __$site_doSitesGet__15() {
/*   868 */                 progress.end();
                            __then();
                          });
                        })(function ___() {
                          __tryCatch(_, function ___() {
                            if (__cont) {
                              __then();
                            } else {
                              _(__e, __r);
                            };
                          });
                        });
                      });
                    })(function ___() {
                      __tryCatch(_, _);
                    });
                  }, true));
                });
              };
/*   872 */   site.doSiteGet = function(options, callback) {
/*   873 */     var progress = cli.progress("Retrieving site information");
/*   874 */     getChannel().path(options.subscription).path("services").path("webspaces").path(options.site.webspace).path("sites").path(options.site.name).query("propertiesToInclude", "repositoryuri,publishingpassword,publishingusername").GET(function(err, result) {
/*   884 */       progress.end();
/*   885 */       if (err) {
/*   886 */         logError("Failed to get site info", err);
/*   887 */         if ((err.Code === "NotFound")) {
/*   888 */           return cacheUtils.deleteSite(options, function() {
/*   889 */             return callback(err, result);
                      });
                    }
                  ;
                  }
/*   892 */        else {
/*   893 */         return cacheUtils.saveSite(options, result, function(err) {
/*   894 */           log.verbose("Site", clean(result));
/*   895 */           return callback(err, result);
                    });
                  }
                ;
/*   898 */       return callback(err, result);
                });
              };
/*   902 */   site.doSiteConfigGet = function(options, callback) {
/*   903 */     var progress = cli.progress("Retrieving site config information");
/*   904 */     getChannel().path(options.subscription).path("services").path("webspaces").path(options.site.webspace).path("sites").path(options.site.name).path("config").GET(function(err, result) {
/*   914 */       progress.end();
/*   915 */       if (err) {
/*   916 */         logError("Failed to get site config info", err);
                  }
/*   917 */        else {
/*   918 */         log.verbose("SiteConfig", clean(result));
                  }
                ;
/*   920 */       return callback(err, result);
                });
              };
/*   924 */   site.doRepositoryGet = function site_doRepositoryGet__16(options, _) {
                var siteData;
                var __frame = {
                  name: "site_doRepositoryGet__16",
                  line: 924
                };
                return __func(_, this, arguments, site_doRepositoryGet__16, 1, __frame, function __$site_doRepositoryGet__16() {
/*   925 */       return site.doSiteGet(options, __cb(_, __frame, 1, 19, function ___(__0, __1) {
                    siteData = __1;
/*   926 */         return _(null, getRepositoryUri(siteData));
                  }, true));
                });
              };
/*   929 */   site.doPublishingUsersGet = function site_doPublishingUsersGet__17(options, _) {
                var progress, publishingUsers;
                var __frame = {
                  name: "site_doPublishingUsersGet__17",
                  line: 929
                };
                return __func(_, this, arguments, site_doPublishingUsersGet__17, 1, __frame, function __$site_doPublishingUsersGet__17() {
/*   930 */       progress = cli.progress("Retrieving user information");
                  return (function ___(__then) {
                    (function ___(_) {
                      __tryCatch(_, function __$site_doPublishingUsersGet__17() {
/*   938 */             return getChannel().path(options.subscription).path("services").path("webspaces").path("").query("properties", "publishingUsers").GET(__cb(_, __frame, 9, 34, function ___(__0, __1) {
/*   932 */               publishingUsers = clean(__1);
/*   940 */               log.verbose("PublishingUsers", publishingUsers);
/*   941 */               return _(null, publishingUsers);
                        }, true));
                      });
                    })(function ___(__e, __r, __cont) {
                      (function ___(__then) {
                        __tryCatch(_, function __$site_doPublishingUsersGet__17() {
/*   944 */               progress.end();
                          __then();
                        });
                      })(function ___() {
                        __tryCatch(_, function ___() {
                          if (__cont) {
                            __then();
                          } else {
                            _(__e, __r);
                          };
                        });
                      });
                    });
                  })(function ___() {
                    __tryCatch(_, _);
                  });
                });
              };
/*   952 */   var writers = {
/*   953 */     Site: {
/*   954 */       xml: function(site) {
/*   955 */         return function(req) {
/*   956 */           req.write("<Site xmlns=\"http://schemas.microsoft.com/windowsazure\">");
/*   957 */           req.write("<HostNames>");
/*   958 */           req.write("<string xmlns=\"http://schemas.microsoft.com/2003/10/Serialization/Arrays\">");
/*   959 */           req.write((site.name + utils.getHostNameSuffix()));
/*   960 */           req.write("</string>");
/*   962 */           if (site.hostname) {
/*   963 */             req.write("<string xmlns=\"http://schemas.microsoft.com/2003/10/Serialization/Arrays\">");
/*   964 */             req.write(site.hostname);
/*   965 */             req.write("</string>");
                      }
                    ;
/*   967 */           req.write("</HostNames>");
/*   968 */           req.write("<Name>");
/*   969 */           req.write(site.name);
/*   970 */           req.write("</Name>");
/*   971 */           req.write("</Site>");
/*   973 */           req.end();
                    };
                  }
                }
              };
/*   979 */   function clean(source) {
/*   980 */     if ((typeof (source) === "string")) {
/*   981 */       return source;
                }
              ;
/*   984 */     var target = {
                };
/*   985 */     var hasString = false;
/*   986 */     var hasNonString = false;
/*   987 */     var stringValue = "";
/*   989 */     for (var prop in source) {
/*   990 */       if ((prop == "@")) {
/*   991 */         continue;
                  }
/*   992 */        else {
/*   993 */         if ((((prop === "#") || (prop === "string")) || (prop.substring((prop.length - 7)) === ":string"))) {
/*   994 */           hasString = true;
/*   995 */           stringValue = source[prop];
                    }
/*   996 */          else {
/*   997 */           hasNonString = true;
                    }
                  ;
/*   999 */         target[prop] = clean(source[prop]);
                  }
                ;
                };
/*  1002 */     if ((hasString && !hasNonString)) {
/*  1003 */       return stringValue;
                }
              ;
/*  1005 */     return target;
              };
/*  1008 */   function logEachData(title, data) {
/*  1009 */     var cleaned = clean(data);
/*  1010 */     for (var property in cleaned) {
/*  1011 */       log.data(((title + " ") + property), cleaned[property]);
                };
              };
/*  1014 */   site.logEachData = logEachData;
/*  1016 */   function logError(message, err) {
/*  1017 */     if ((arguments.length == 1)) {
/*  1018 */       err = message;
/*  1019 */       message = undefined;
                }
/*  1020 */      else {
/*  1021 */       log.error(message);
                }
              ;
/*  1024 */     if (err) {
/*  1025 */       if (err.message) {
/*  1027 */         log.verbose("stack", err.stack);
/*  1028 */         log.json("silly", err);
                  }
/*  1030 */        else if (err.Message) {
/*  1032 */         log.json("verbose", clean(err));
                  }
/*  1034 */        else {
                  
                  }
                  
                ;
                }
              ;
              };
/*  1040 */   function isArray(testObject) {
/*  1041 */     return (((testObject && !(testObject.propertyIsEnumerable("length"))) && (typeof testObject === "object")) && (typeof testObject.length === "number"));
              };
/*  1044 */   function toArray(testObject) {
/*  1045 */     return (isArray(testObject) ? testObject : ((typeof testObject === "undefined") ? [] : [testObject,]));
              };
/*  1048 */   function endsWith(str, suffix) {
/*  1049 */     return (str.indexOf(suffix, (str.length - suffix.length)) !== -1);
              };
/*  1052 */   function exec(cmd, cb) {
/*  1053 */     child_process.exec(cmd, function(err, stdout, stderr) {
/*  1054 */       cb(err, {
/*  1055 */         stdout: stdout,
/*  1056 */         stderr: stderr
                  });
                });
              };
            };
